/*-------------------------------------------------------------------------+
| Copyright 2015 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.create.taskmapping;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.partitionmapping.PartitionMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskgraph.AbstractTaskGraphEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.abstractmapping.AbstractTaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.abstractmapping.AbstractTaskMappingEntry;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.create.Creates;
import org.fortiss.af3.exploration.alg.exception.ExplorationException;
import org.opt4j.core.Genotype;
import org.opt4j.core.problem.Creator;

import com.google.inject.Provides;

/**
 * {@link Creator} for an {@link AbstractTaskMappingEncoding}, i.e. a {@link Genotype} that may
 * refer which need to be instantiated.
 * 
 * @author diewald
 */
public class AbstractTaskMappingCreator extends
		TaskMappingCreator<AbstractTaskMappingEntry, AbstractTaskMappingEncoding> {

	/** Creates an {@link AbstractTaskGraphEncoding} initialized with random allocations. */
	@Provides
	@Creates
	public AbstractTaskMappingEncoding create(PartitionMappingEncoding partEnc,
			AbstractTaskGraphEncoding atgEnc) throws ExplorationException {
		return new AbstractTaskMappingEncoding(partEnc, atgEnc, true);
	}

	/** {@inheritDoc} */
	@Override
	public AbstractTaskMappingEncoding create() {
		// TODO Auto-generated method stub
		return null;
	}
}
