/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.problem.instantiatetaskgraph;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskgraph.AbstractTaskGraphEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskgraph.InstantiatedAcyclicTaskGraphEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskgraph.InstantiatedTaskGraphEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.FailSilentTaskMappingEntry;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.InstantiatedTaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.InstantiatedTaskMappingEntry;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.decode.ComposableDecoder;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.decode.Decodes;
import org.fortiss.af3.exploration.alg.dse.module.DecoderModule;
import org.opt4j.core.Genotype;

import com.google.inject.Provides;

/**
 * {@link ComposableDecoder} that takes an {@link InstantiatedTaskMappingEncoding} as input and
 * generates an {@link InstantiatedAcyclicTaskGraphEncoding} from it.
 * 
 * @author diewald
 */
public class InstantiatedTaskMappingDecoderAcyclic<T extends InstantiatedTaskMappingEntry> extends
		DecoderModule<InstantiatedAcyclicTaskGraphEncoding<T>> {

	@Provides
	@Decodes
	public InstantiatedAcyclicTaskGraphEncoding<FailSilentTaskMappingEntry> decodeFailSilent(
			AbstractTaskGraphEncoding atgEnc,
			InstantiatedTaskGraphEncoding<FailSilentTaskMappingEntry> itgEnc) {
		// TODO: Replace with "decode". Fixup type (generic) conversion.
		return new InstantiatedAcyclicTaskGraphEncoding<FailSilentTaskMappingEntry>(
				itgEnc.getTaskGraphs(), atgEnc.getHyperPeriod());
	}

	public InstantiatedAcyclicTaskGraphEncoding<T> decode(AbstractTaskGraphEncoding atgEnc,
			InstantiatedTaskGraphEncoding<T> itgEnc) {
		InstantiatedAcyclicTaskGraphEncoding<T> iAtgEnc =
				new InstantiatedAcyclicTaskGraphEncoding<T>(itgEnc.getTaskGraphs(),
						atgEnc.getHyperPeriod());
		return iAtgEnc;
	}

	/** {@inheritDoc} */
	@Override
	public InstantiatedAcyclicTaskGraphEncoding<T> decode(Genotype genotype) {
		// TODO Auto-generated method stub
		return null;
	}
}
