/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.evaluator.constraint;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.MappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.partitionmapping.Partition;
import org.fortiss.af3.exploration.alg.dse.evaluator.TaskMappingParser;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ITaskAdapter;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.mappers.TaskMapper;
import org.fortiss.af3.exploration.dsl_v2.model.expression.IExpression;
import org.fortiss.af3.exploration.dsl_v2.model.function.Maximize;
import org.fortiss.af3.exploration.dsl_v2.model.function.Minimize;
import org.fortiss.af3.exploration.model.ExplorationConstraint;

/**
 * Parses and evaluates an {@link IExpression} given in an {@link ExplorationConstraint}.
 * 
 * @author diewald
 */
public class MappingParserConstraint extends TaskMappingParser<Boolean> {

	/** Constructor. */
	public MappingParserConstraint(MappingEncoding<?, ITaskAdapter<?>, Partition, ?> mapping,
			MappingEncoding<?, Partition, ?, ?> virtMapping, IExpression expression,
			TaskMapper<EObject> taskMapper) {
		super(mapping, virtMapping, expression, taskMapper);
	}

	/** {@inheritDoc} */
	@Override
	public Object visit(Maximize max) throws Exception {
		// Handled in the preprocessing.
		return null;
	}

	/** {@inheritDoc} */
	@Override
	public Object visit(Minimize min) throws Exception {
		// Handled in the preprocessing.
		return null;
	}

	/** {@inheritDoc} */
	@Override
	public Boolean parse() throws Exception {
		return expression.accept(this, Boolean.class);
	}
}
